from collections import deque


def fd(n, skl, pos):
    d = [-1] * (n + 1)
    d[pos] = 0
    adj = [[] for _ in range(n + 1)]
    for a, b in skl:
        adj[a].append(b)
        adj[b].append(a)

    q = deque([pos])
    while q:
        cur = q.popleft()
        for coc in adj[cur]:
            if d[coc] == -1:
                d[coc] = d[cur] + 1
                q.append(coc)

    return d


def s(n, skl, oxr):
    oxrn = set()
    for pos, vin in oxr:
        d = fd(n, skl, pos)
        for s in range(1, n + 1):
            if d[s] != -1 and d[s] <= vin:
                oxrn.add(s)
    return oxrn


n, m, k = map(int, input().split())
sklads = []
for i in range(m):
    a, b = map(int, input().split())
    sklads.append([a, b])
oxrans = []
for i in range(k):
    c, d = map(int, input().split())
    oxrans.append([c, d])
g = s(n, sklads, oxrans)
if not g:
    print(0)
    print()
else:
    print(len(g))
    print(*sorted(g))
